#pragma once

#include "AbstractVisualNode.h"

class QuantumCircuit;
class QuantumTerminalNode;

class QuantumCircuitNode : public AbstractVisualNode
{
public:
	QuantumCircuitNode(const Transform& t = {});

	void setContent(QuantumCircuit* circuit);

	void update(SceneInfo* sceneInfo);
private:
	void createOrUpdateGeometry(SceneInfo* sceneInfo);

	bool mContentDirty{ true };
	QuantumCircuit* mContent{ nullptr };

	std::vector<std::unique_ptr<QuantumTerminalNode> > mInputTerminalNodes;
};