#pragma once

#include "AbstractVisualNode.h"

class QuantumTerminal;
class EquationNode;
class LatexMathExpression;

class QuantumTerminalNode : public AbstractVisualNode
{
public:
	QuantumTerminalNode(const Transform& transform);

	void setContent(QuantumTerminal* terminal);

	void update(SceneInfo* sceneInfo);
private:
	void createOrUpdateGeometry(SceneInfo* sceneInfo);

	QuantumTerminal* mContent{ nullptr };
	bool mContentDirty{ true };

	std::unique_ptr<LatexMathExpression> mLabelExpression;
	std::unique_ptr<EquationNode> mLabel;
};